/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.benutzerverwaltung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.benutzerverwaltung.boundary.AbstractBenutzerParameterSearchParameters;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerParameterChangeEvent;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerParameterConversationStore;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerParameterExtendedDAO;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerParameterSearch;
import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerParameterSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameter;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameterMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractBenutzerParameterSearchView.COMPONENT_NAME)
@View(viewId = AbstractBenutzerParameterSearchView.VIEW_ID, useCase = UseCasePermission.BENUTZER_PARAMETER_SEARCH)
public abstract class AbstractBenutzerParameterSearchView extends AbstractElectSearchView<BenutzerParameter> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "benutzerParameterSearchView";
  
  public static final String VIEW_ID = "/benutzerverwaltung/benutzer-parameter-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractBenutzerParameterSearchView requestHandler;

  @Inject
  private transient BenutzerParameterExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(BenutzerParameterConversationStore.class)
  protected transient BenutzerParameterConversationStore conversationStore;

  @Inject
  protected transient BenutzerParameterSearch search;

  @Inject
  @ConversationGroup(AbstractBenutzerParameterSearchParameters.class)
  protected transient BenutzerParameterSearchParameters searchParameters;

  @Inject
  protected transient BenutzerParameterMeta entityMeta;

  public AbstractBenutzerParameterSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public BenutzerParameter getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(BenutzerParameter entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public BenutzerParameterSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<BenutzerParameter> getEagerLoadingCollector() {
    return EagerLoadingCollector.<BenutzerParameter> create();
  }

  @Override
  public List<BenutzerParameter> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<BenutzerParameter> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onBenutzerParameterChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) BenutzerParameterChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractBenutzerParameterSearchView {

    @View
    @Inject
    private transient Instance<AbstractBenutzerParameterSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractBenutzerParameterSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
